<?php
/**
 * @package Direct Mail
 * @author e3 Software
 * @version 1.1
 */
/*
Plugin Name: Direct Mail Subscribe Form
Plugin URI: http://www.ethreesoftware.com/directmail/feature.php?f=autosub
Description: This plugin allows visitors to your blog to subscribe to your Direct Mail subscription groups. Add the widget to your sidebar by navigating to Appearance > Widgets.
Author: e3 Software
Version: 1.1
Author URI: http://www.ethreesoftware.com/directmail
*/

/*

Copyright 2012 e3 Software

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

*/


define('DM_CAPABILITIES_THRESHOLD', 'manage_options');

add_action( 'wp_head',  'directmail_sg_client_css'  ); 
add_action( 'admin_head', 'directmail_sg_admin_css'  );
add_action( 'plugins_loaded', 'directmail_sg_init' );
register_activation_hook( __FILE__,  'activate' );
register_deactivation_hook( __FILE__, 'deactivate' );

function activate()
{
    $data = array(
        'title'    => 'Subscribe to My Mailing List',
        'group_id' => '',
        'capture'  => 'email_only'
    );
    
    if ( !get_option( 'directmail_sg' ) ) {
      add_option( 'directmail_sg', $data );
    }
    else {
      update_option( 'directmail_sg', $data );
    }
}

function deactivate()
{
    delete_option( 'directmail_sg' );
}

function directmail_sg_init() 
{
    if ( !function_exists( 'register_sidebar_widget' ) || !function_exists( 'register_widget_control' ) )
        return; 

	wp_register_sidebar_widget(
		'directmail_sg',
		'Direct Mail Subscribe Form',
		'directmail_sg_client_form',
		array( description => __( 'Allow visitors to subscribe to your Direct Mail subscription groups.' ) )
	);
	
	wp_register_widget_control( 'directmail_sg', 'Direct Mail Subscribe Form', 'directmail_sg_admin_form' );
}    

function directmail_sg_client_form( $args ) 
{
    extract($args);
    $options            = get_option('directmail_sg');
    $subscription_title = empty($options['title']) ? '' : $options['title'];
    $group_id        	= $options['group_id'];
    $capture   			= $options['capture'];

    echo $before_widget; 
    echo $before_title;
    echo $subscription_title;
    echo $after_title;
    directmail_sg_print_subscription_form( $group_id, $capture );
    echo $after_widget;
}

function directmail_sg_print_subscription_form( $group_id, $capture ) 
{
    echo "<form class='directmail_sg' method='post' action='http://dm-mailinglist.com/subscribe' accept-charset='UTF-8' target='_blank'>\n";
    echo "<input type='hidden' name='form_id' value='$group_id'>\n";
    
	echo '<table border=0 cellpadding=0 cellspacing=0 width=100%>';
	
    if ( $capture == 'email_and_name' ) {
        echo "<tr><td><span>First Name:</span><br><input type='text' name='first_name' size='20'></td></tr>\n";
        echo "<tr><td><span>Last Name:</span><br><input type='text' name='last_name' size='20'></td></tr>\n";
    }
    
    echo "<tr><td><span>Email:</span><br><input type='text' name='subscriber_email' size='20'></td></tr>\n"; 
    echo "<tr><td><input type='submit' value='Subscribe'></td></tr>\n";

	echo '</table>';

    echo "</form>\n";
}

function directmail_sg_admin_form()
{
    $options = get_option('directmail_sg');

    if ( $_POST['directmail_sg_submit'] ) {
        $newoptions['title']    = strip_tags(stripslashes($_POST['directmail_sg_title']));
        $newoptions['group_id'] = strip_tags(stripslashes($_POST['directmail_sg_group_id']));
        $newoptions['capture']  = $_POST['directmail_sg_capture'];
        
        if ( $options != $newoptions ) {
            $options = $newoptions;
            update_option('directmail_sg', $options);
        }
    }
       
    $title              = htmlspecialchars($options['title'], ENT_QUOTES);
    $group_id           = htmlspecialchars($options['group_id'], ENT_QUOTES);
    $email_name_checked = $options['capture'] == "email_and_name" ? "checked='checked'" : "";
    $email_checked      = $options['capture'] == "email_only"     ? "checked='checked'" : "";
    
    echo "<label class='directmail_sg_label'>Title:</label>   <input type='text' id='directmail_sg_title' name='directmail_sg_title' value='$title' size=26 />";
    echo "<label class='directmail_sg_label'>Form ID:</label><input type='text' id='directmail_sg_group_id' name='directmail_sg_group_id' value='$group_id' size=16/><br/>";
    echo "<a href='http://www.directmailmac.com/support/?a=327' target='_blank'>Where is my form id?</a><br><br>";
    echo "<input type='radio' id='directmail_sg_capture' name='directmail_sg_capture' value='email_only' ". $email_checked . "/>&nbsp;Ask for email only<br/>";
    echo "<input type='radio' id='directmail_sg_capture' name='directmail_sg_capture' value='email_and_name' ". $email_name_checked . " />&nbsp;Ask for name and email<br/>";
    echo "<input type='hidden' name='directmail_sg_submit' id='directmail_sg_submit' value='1' /><br/>";
}

function directmail_sg_client_css()
{
    echo "
    <style type='text/css'>
    .directmail_sg
    {
        font-weight: bold; 
        display:block;
        margin:0px;
        padding-top:5px;
        padding-bottom:5px;
    }
    </style>";
}

function directmail_sg_admin_css()
{
    echo "
    <style type='text/css'>
    .directmail_sg_label
    {
     margin:0px;
     padding: 5px;
     display:block;
    }
    </style>";
}

?>
